#ifndef PSPSDK_H
#define PSPSDK_H

#include "syscall.h"

#define RGB(r,g,b) ((((b>>3) & 0x1F)<<10)|(((g>>3) & 0x1F)<<5)|(((r>>3) & 0x1F)<<0)|0x8000)

#define		PIXELSIZE	1				//in short
#define		LINESIZE	512				//in short
#define		FRAMESIZE	0x44000			//in byte

//480*272 = 60*38
#define CMAX_X 60
#define CMAX_Y 34

////////////////////////////////////////////////////////////////////////////////
//Av֌J
extern ctrl_data_t pspPadData;
extern u32 new_pad;
extern u32 now_pad;
extern char szCurrentPath[MAX_PATH];

#define SOUND_BANKLEN 2048
extern int wavout_enable;
extern unsigned int cur_play;
extern short sound_buf[SOUND_BANKLEN*4*2];
//TEhobt@PoN̗eʁBSoNœKɃEhr
//PGA_SAMPLES̔{ɂ邱ƁBPGA_SAMPLESƓƑ_Ȃ̂ŒӁB - LCK

extern int pspMain(void);
extern int pspExit(void);

////////////////////////////////////////////////////////////////////////////////
//// Graphics
char *pspGetVramAddr(unsigned long x,unsigned long y);
void pspWaitVn(unsigned long count);
void pspWaitV();
void pspDrawFrame(unsigned long x1, unsigned long y1, unsigned long x2, unsigned long y2, unsigned long color);
void pspFillBox(unsigned long x1, unsigned long y1, unsigned long x2, unsigned long y2, unsigned long color);
void pspFillVRAM(unsigned long color);
void pspBitBlt(unsigned long x,unsigned long y,unsigned long w,unsigned long h,unsigned long mag,const unsigned short *d);
void pspTextOut(int x,int y,int col,const unsigned char *str) ;
void pspPrint(unsigned long x,unsigned long y,unsigned long color,const char *str);
void pspPutChar(unsigned long x,unsigned long y,unsigned long color,unsigned long bgcolor,unsigned char ch,char drawfg,char drawbg,char mag);
void pspScreenFlip();
void pspScreenFlipV();
void pspScreenFrame(long mode,long frame);
void pspLocate(unsigned long x, unsigned long y);
void pspColor(unsigned long fg, unsigned long bg);
void pspDraw(char drawfg, char drawbg);
void pspSetmag(char mag);
void pspCls();
void pspGraphicsInit();


////////////////////////////////////////////////////////////////////////////////
//// Input
void pspInputInit();
void pspReadPad(void);

////////////////////////////////////////////////////////////////////////////////
//// Audio
#define SOUND_BUFLEN 512*2*6

int pspAudioInit();

////////////////////////////////////////////////////////////////////////////////
//// System

////////////////////////////////////////////////////////////////////////////////
//// C Runtime
int _memcmp(const void *buf1, const void *buf2,int n);
void* _memcpy(void *buf1, const void *buf2, int n);
void* _memset(void *buf, int ch, int n);
int _strlen(const char *s);
char* _strcpy(char *dest, const char *src);
char* _strrchr(const char *src, int c);
char* _strcat(char *dest, const char *src);
int _stricmp(const char *str1, const char *str2);
int _strcmp(const char *str1, const char *str2);
char *_strncat(char *s1,char *s2,int n) ;
char *_strncpy(char *s1,char *s2,int n);
void _itoa(int val, char *s);
static inline void __memcpy4a(unsigned long *d, unsigned long *s, unsigned long c);



#endif
